# Trackmania Ultrawide UI Fix plugin for Openplanet

This [Openplanet](https://openplanet.dev/) plugin fixes the in-game UI of Trackmania 2020 for aspect ratios wider than 16:9 by moving the UI elements back to the edge of the screen.

## Supported UI elements
* Best & previous times (`Race_BestRaceViewer`)
* Time Attack countdown (`Race_Countdown`)
* Messages in the top left (`Race_DisplayMessage`)
* Lap counter (`Race_LapsCounter`)
* Records (`Race_Record`)
* Respawn & Give up prompts (`Race_RespawnHelper`)
* Spectator mode picker (`Race_SpectatorBase_Commands`)
* Checkpoint times (`Race_TimeGap`)
* Warmup information (`Race_WarmUp`)
* COTD
  * Qualification information (`COTDQualifications_QualificationsProgress`)
  * Qualification results (`COTDQualifications_Ranking`)
  * Knockout results (`Knockout_KnockoutInfo`)
* Royal
  * Recently finished players (`Royal_FinishFeed`)
  * Team ranking (`Royal_LiveRanking`)
  * Restart prompt (`Royal_RespawnHelper`)
  * Team results (`Royal_TeamScore`)
* Ranked
  * Player positions and points (`Teams_Matchmaking_LiveRanking`)
* ~~Slide out medal banner (`clip-medal-banner`)~~ - temporarily disabled because of [issue #2](https://gitlab.com/dpeukert/tm-ultrawide-ui-fix/-/issues/2)

## Not yet supported UI elements
* Small chat window ([issue #1](https://gitlab.com/dpeukert/tm-ultrawide-ui-fix/-/issues/1))
* Connection error icon ([issue #11](https://gitlab.com/dpeukert/tm-ultrawide-ui-fix/-/issues/11))
* Elements that appear while not driving (not my focus, but MRs are welcome)

## UI elements that won't be supported
* Animated main screen (already provided by the [Menu Background Chooser](https://openplanet.dev/plugin/menu-bg-chooser) plugin)

# How to use this plugin
* Trackmania 2020 with Openplanet installed is required
* Search for `Ultrawide UI Fix` in the Plugin Manager
* Alternatively, download the plugin from its [Openplanet plugin page](https://openplanet.dev/plugin/ultrawideuifix) and place it Openplanet's Plugins directory

## Source code
The source code of this plugin is available on [GitLab](https://gitlab.com/dpeukert/tm-ultrawide-ui-fix) under the MIT license.

## Bugs & issues
If you run into any bugs or issues, report them in the [issue tracker](https://gitlab.com/dpeukert/tm-ultrawide-ui-fix/-/issues).

## Authors
* \>= 3.0.0 - Dan_VQ / Daniel Peukert
* < 3.0.0 - [Eierpflanze / Felix Meyer](https://github.com/Eierpflanze)
